/*
Copyright (c) 2006, Mathias Kende
sectionpc@gmail.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit
persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*/

#include <mk_socket.h>
#include <advio.h>

advio_console cons;

void on_connection_request(mk_socket& sck,void* data);
void on_data_arrival(mk_socket& sck,char* str,int size,void* data);

int main()
{
  int port;
  cons << "Sur quel port doit-on couter ? " >> port;
  mk_socket sock;
  cons.cls();

  //On enregistre les fonctions de rappel (celle qui seront appel par le socket lors de certains vnements).
  sock.SetConnectionRequestCallBack(on_connection_request);
  sock.SetDataArrivalCallBack(on_data_arrival);

  sock.Listen(port); //On connecte le socket en mode coute sur le port "port"
  sock.WaitClose();  //On attend que la connection se ferme et que le socket n'coute plus (pour empecher que le programme se quite avant).

  return 0;
}

//Cette fonction est appele par le socket lorsque qu'un autre socket se connecte au serveur.
void on_connection_request(mk_socket& sck,void* data)
{
  sck.Accept(sck);    //On accepte la connexion, et on utilise pour cel le socket qui coutait prcdemment. De toute manire, on n'attend plus d'autre connexions.
  char texte[255];

  //Cette boucle lis les entre clavier et envoie sur le rseau le texte qui est tap.
  while (1)
  {
    cons >> texte;
    sck.Send(texte);
    sck.Send("\n");
  }
}

//Cette fonction est appel lorsque des donnes arrive du rseau. La fonction ne fait qu'imprimer ce texte  l'cran.
void on_data_arrival(mk_socket& sck,char* str,int size,void* data)
{
  cons.SetColor(ADVIO::TEXTE_BLEU_CLAIR);
  cons << (char*)str;
  cons.SetColor(ADVIO::TEXTE_BLANC);
}

