/*
Copyright (c) 2006, Mathias Kende
sectionpc@gmail.com

L'utilisation de cette bibliothque est soumise  la licence SectionPC dont vous devez avoir
eu une copie avec la bibliothque. Si ce n'est pas le cas vous pouvez la lire l :
http://lib.sectionpc.info/licence/licence.html

La lecture de ce fichier entraine l'acceptation de cette licence.
*/

#include "stdafx.h"

mk_socket::mk_socket()
{ 
  etat=IDLE;
#ifdef WIN32
  Sock_Data=new WSADATA;
  if (WSAStartup(MAKEWORD(2,0),Sock_Data))
    throw "Erreur: impossible d'initialiser les sockets";
#endif
  OnConnect=NULL;
  DataArrival=NULL;
  OnClose=NULL;
  OnConnectionRequest=NULL;
  proc_count=0;
}

mk_socket::mk_socket(void (*onconnect)(mk_socket&,void*),void* data_connect,void (*onclose)(mk_socket&,void*),void* data_close,void (*dataarrival)(mk_socket&, char*, int, void*),void* data_data,void (*onconnectionrequest)(mk_socket&, void*),void* data_request,void(*onerror)(mk_socket&,int,void*),void* data_error)
{
  etat=IDLE;
#ifdef WIN32
  Sock_Data=new WSADATA;
  if (WSAStartup(MAKEWORD(2,0),Sock_Data))
    throw "Erreur: impossible d'initialiser les sockets";
#endif
  SetOnConnectCallBack(onconnect,data_connect);
  SetOnCloseCallBack(onclose,data_close);
  SetDataArrivalCallBack(dataarrival,data_data);
  SetConnectionRequestCallBack(onconnectionrequest,data_request);
  SetOnErrorCallBack(onerror,data_error);
  proc_count=0;
}



mk_socket::~mk_socket()
{
  if (etat!=IDLE)
    Close();
#ifdef WIN32
  delete Sock_Data;
  WSACleanup();
#endif
}

void mk_socket::SetDataArrivalCallBack(void (*dataarrival)(mk_socket&,char*,int,void*),void* data)
{
  DataArrival=dataarrival;
  DataArrival_Data=data;
}

void mk_socket::SetOnConnectCallBack(void (*onconnect)(mk_socket&,void*),void* data)
{
  OnConnect=onconnect;
  Connect_Data=data;
}

void mk_socket::SetOnCloseCallBack(void (*onclose)(mk_socket&,void*),void* data)
{
  OnClose=onclose;
  Close_Data=data;
}

void mk_socket::SetConnectionRequestCallBack(void (*connection)(mk_socket&,void*),void* data)
{
  OnConnectionRequest=connection;
  ConnectionRequest_Data=data;
}

void mk_socket::SetOnErrorCallBack(void (*error)(mk_socket&,int,void*),void* data)
{
  OnError=error;
  Error_Data=data;
}

bool mk_socket::Connect(const char *hostname,unsigned short port)
{
  if (GetState()!=IDLE)
  {
    send_error(STATE_IS_NOT_IDLE);
    return false;
  }

  unsigned long ip=GetIP(hostname);
  if (ip==INADDR_NONE)
  {
    send_error(BAD_HOSTNAME);
    return false;
  }
  sockaddr_in sin=FillAddr(ip,port); 
  sock = socket(PF_INET, SOCK_STREAM, 0);
/**************************************************************
IL FAUT CONTINUER A ECRIRE LA GESTION D'ERREURS A PARTIR DE LA.
**************************************************************/
  //Et voir comment traiter les code d'erreur renvoy par la bibliothque standard...

  if (sock==INVALID_SOCKET)
    return false;
  int ret=connect(sock,(sockaddr*)&sin,sizeof(sockaddr)); 
  if (ret==0)
  {
    etat=CONNECTED;
    new_thread(mk_SckProc,this);
    if (OnConnect!=NULL)
      new_thread(mk_ConnectProc,this);
    return true;
  }
  else
  {
    close_socket(sock);
    return false;
  }
}

bool mk_socket::Listen(unsigned short port)
{
  if (GetState()!=IDLE)
    return false;

  sock = socket(PF_INET, SOCK_STREAM, 0);
  if (sock==INVALID_SOCKET)
    return false;
  sockaddr_in addr=FillAddr(INADDR_ANY,port);;

  if (bind(sock,(sockaddr*)&addr, sizeof(sockaddr)))
  {
    close_socket(sock);
    return false;
  }
  if (listen(sock,20))
  {
    close_socket(sock);
    return false;
  }
  etat=LISTEN;
  new_thread(mk_SckProc,this);
  return true;
}
      
bool mk_socket::Close()
{
  if (GetState()==IDLE)
    return false;

  etat=IDLE;
  close_socket(sock);

  if (OnClose!=NULL)
  {
    ++proc_count;
    OnClose(*this,Close_Data);
    --proc_count;
  }
  return true;
}

ETAT mk_socket::GetState()
{
  return etat;
}

bool mk_socket::Send(const char* str)
{
  return Send(str,(int)strlen(str)+1);
}

bool mk_socket::Send(const char* data,int size)
{
  if (GetState()!=CONNECTED)
    return false;
  int ret=send(sock,data,(int)size,0);
  if (ret==SOCKET_ERROR)
    return false;
  else if (ret==0)    //Pour viter un "stack overflow"
    return false;
  else if (ret<size)
    return Send(data+ret,size-ret);
  else
    return true;
}


//Il faut implmenter la gestion des erreurs dans cette procdure  l'aide d'une fonction de rappel OnError.
void mk_socket::thread_proc()
{
  switch (GetState())
  {
    case CONNECTED:
      {
      char buffer[SIZE_BUFFER]; 
      int ret;

      while (GetState()==CONNECTED)
      { 
        ret=recv(sock, buffer,SIZE_BUFFER-1,0);
        if (ret<1||ret>10000)
          break;
        ++proc_count;
        DataArrival(*this,buffer,ret,DataArrival_Data);
        --proc_count;
      }
      Close();
    }
    case LISTEN:
    {
      while (GetState()==LISTEN)
      {
        new_sock = accept(sock,NULL,0);
        if (new_sock==INVALID_SOCKET)
          continue;
        etat=ACCEPT_PENDING;
        ++proc_count;
        OnConnectionRequest(*this,ConnectionRequest_Data);
        --proc_count;
        if (GetState()==ACCEPT_PENDING)
        {
          close_socket(new_sock);
          etat=LISTEN;
        }
      }
      
    }
  }
  return;
}

bool mk_socket::Accept(mk_socket& new_sck)
{
  if (GetState()!=ACCEPT_PENDING)
    return false;
  if (&new_sck==this)
  {
    close_socket(sock);
    sock=new_sock;
    etat=CONNECTED;
    new_thread(mk_SckProc,this);
    if (OnConnect!=NULL)
      new_thread(mk_ConnectProc,this);
  }
  else
  {
    if (new_sck.GetState()!=IDLE)
      return false;
    new_sck.sock=new_sock;
    new_sck.etat=CONNECTED;
    etat=LISTEN;
    new_thread(mk_SckProc,&new_sck);
    if (new_sck.OnConnect!=NULL)
      new_thread(mk_ConnectProc,&new_sck);
  }
  return true;
}

bool mk_socket::WaitClose()
{
  while(GetState()!=IDLE)
    mk_wait(20);
  return true;
}

void mk_socket::Kill()
{
  Close();
  new_thread(mk_DieProc,this);
}

CALLBACK_PROC mk_SckProc(void* sck)
{
  ((mk_socket*)sck)->thread_proc();
  return NULL;
}

CALLBACK_PROC mk_ConnectProc(void* sck)
{
  ++(((mk_socket*)sck)->proc_count);
  ((mk_socket*)sck)->OnConnect(*(mk_socket*)sck,((mk_socket*)sck)->Connect_Data);
  --(((mk_socket*)sck)->proc_count);
  return NULL;
}

CALLBACK_PROC mk_DieProc(void* sck)
{
  int i;
  for (i=0;i<KILL_TIMEOUT;i++)
  {
    if (((mk_socket*)sck)->proc_count==0)
      break;
    mk_wait(1000);
  }
  delete (mk_socket*)sck;
  return NULL;
}

