/*
Copyright (c) 2006, Mathias Kende
sectionpc@gmail.com

L'utilisation de cette bibliothque est soumise  la licence SectionPC dont vous devez avoir
eu une copie avec la bibliothque. Si ce n'est pas le cas vous pouvez la lire l :
http://lib.sectionpc.info/licence/licence.html

La lecture de ce fichier entraine l'acceptation de cette licence.


  Installation :
  -Copier ce fichier (mk_socket.h) dans le dossier "include" de votre compilateur.
  -Copier le fichier bibliothque (mk_socket.lib pour VC++ ou mk_sock.a pour Dev C++)
  dans le dossier "lib" de votre compilateur.

  Utilisation :

  Sous Dev C++ vous devez rajoutter dans les paramtres du projet la bibliothque mk_sock.a.
  Pour cel, dans les proprit du projet (ctrl+P) dans l'onglet linker (selon les versions)
  cliquez sur parcourir et slectionnez le fichier mk_sock.a. Vous devez aussi rajoutter le
  fichier libws2_32.a de la mme manire, et qui se trouve dan le dossier lib du Dev C++.
  Sous VC++ il n'y a rien de particulier  faire.

  Ensuite pour utiliser la bibliothque vous devez inclure le fichier mk_socket.h et c'est tout :
  #include <mk_socket.h>

  Vous pouvez ensuite utiliser les objets de type mk_socket pour grer trs simplement les sockets
  internet aussi bien en client qu'en serveur. Pour plus de dtail sur l'utilisation de cet
  objet (en attandant que j'crive une vritable aide), reportez-vous  la suite du fichier
  car toutes les fonctions sont commentes.


  Si vous avez des ides, des questions, des commentaires, ou si vous rencontrez des bugs ou
  n'importe quoi d'autre, n'hsitez pas  m'crire  sectionpc@gmail.com.

*/

#ifndef _MK_SOCKET_
  #define _MK_SOCKET_
#ifdef _MSC_VER   //Sur VC++
  #define USING_VCPP
#else             //Sur Dev C++
  #define USING_DEVCPP
#endif
#ifndef MK_SOCKET_COMPIL    //C'est une constante dfinit lors de la compilation de la lib elle mme.
#pragma comment(lib,"mk_socket")  //bien sr gcc se fache en Wall, mais il a qu' faire comme dit la norme : se la fermer lorsqu'il ne comprend pas les pragma.
#endif
#ifndef _WINDOWS_
#ifndef _WINDOWS_H
#  ifdef WIN32
     struct WSADATA;
#  endif
   typedef unsigned int SOCKET;
#endif
#endif
#ifndef NULL
#  define NULL 0
#endif
#ifdef WIN32
#  define CALLBACK_PROC unsigned long __stdcall
#else
#  define CALLBACK_PROC void*
#endif


// Liste des tats qui peuvent tre renvoys par la fonction GetState (voir ci-dessous).
enum ETAT
{
  IDLE,             //Le socket est ferm.
  CONNECTED,        //Le socket est connect  un autre socket avec lequel il peut changer des donnes.
  LISTEN,           //Le socket est ouvert et attend d'autre connexions.
  ACCEPT_PENDING    //Une demande de connexions a t recu sur le socket (qui tait donc auparavant dans l'tat LISTEN) et elle n'a pas encore t accpt ou refus.
};

#define SIZE_BUFFER 1024

/*
Sauf indication contraire, toutes les fonctions qui renvoient des boolens renvoie true si
l'excution de la fonction s'est droule dans problmes ou false s'il y a eu une erreur.
*/

class mk_socket
{
  public:
    mk_socket();
    ~mk_socket();

    mk_socket(void (*onconnect)(mk_socket&,void*),void*,void (*onclose)(mk_socket&,void*),void*,void (*dataarrival)(mk_socket&, char*, int, void*),void*,void (*onconnectionrequest)(mk_socket&, void*),void*,void(*onerror)(mk_socket&,int,void*),void*);
    // Cette fonction permet de spcifier ds la cration de l'objet mk_socket quelles seront
    // les fonctions qui vont grer les vnements. Certain des pointeurs peuvent tre remplac
    // par NULL s'il les fonction ne sont pas ncessaire.
    // Pour plus de dtails se reporter ci-dessous.

    bool Connect(const char *hostname,unsigned short port);
    // Cette fonction connecte le socket  un autre socket (qui doit tre en mode LISTEN s'il s'agit d'un mk_socket).
            // hostname est l'adresse IP ou DNS o se trouve le socket distant auquel on se connecte.
            // port est le port sur lequel coute le socket distant.
    // Pour l'instant, le seul mode de connexion est TCP.

    bool Listen(unsigned short port);
    // Cette fonction mets le socket en mode attente de connection.
            // port est le port sur lequel on coute.
    // Le socket coute sur toutes les adresse IP de la machine.

    bool Close();
    // Cette fonction ferme la socket.
    // Que la socket soit en mode CONNECTED ou LISTEN cette fonction ferme la connexion
    // et mets la socket en mode IDLE.

    bool Send(const char* str);
    // Cette fonction envoie une chaine de caractres sur le rseau.
            // str est la chaine de caractres termin par un zro que vous voulez envoyer.
    // Le socket doit tre connect  un autre socket pour que vous puissiez envoyer des donnes.

    bool Send(const char* data,int size);
    // Cette fonction envoie des donnes quelconques sur le rseau.
            // data est un pointeur vers la zone mmoire o son stockes les donnes  envoyes.
            // size est la taille en octets des donnes  envoyes.
    // Le socket doit tre connect  un autre socket pour que vous puissiez envoyer des donnes.

    bool Accept(mk_socket& new_sock);
    // Accepte une demande de connexions sur le socket.
            // new_sock est l'objet mk_socket qui sera connect au socket qui a demand la connexion.
    // La fonction accept ne peut tre appele que lorsque le socket est en mode ACCEPT_PENDING,
    // c'est  dire, au sein de la fonction appel lors de l'vnement ConnectionRequest.
    // Lorsque vous appelez cette fonction, le socket qui a recu la demande est de nouveau en
    // mode LISTEN, pret  recevoir des demandes de connexions sur le mme port sauf si vous
    // le fermer ou si vous donnez ce mme socket en paramtre  la fonction Accept auquel cas
    // il se retrouve en mode CONNECTED, conect avec le socket qui a demand la connexion.

    bool WaitClose();
    // Cette fonction bloque l'excutiondu programme jusqu' ce que le socket se ferme.
    // Elle permet d'empcher la fin prmature d'un programme lorsque tout le traitement
    // doit tre fait au sein des fonctions appeleslors des vnements.

    ETAT GetState();
    // Cette fonction renvoie l'tat dans lequel se trouve le socket.
    // La valeur renvoye est memebre du type d'numaration ETAT (voir plus haut).

    void Kill();
    // Cette fonction dtruit l'objet mk_socket. Elle ne doit tre appel que pour un objet
    // qui a t cr  l'aide de l'oprateur new. Et lorsque la fonction est utilise, elle
    // remplace l'utilisation de delete (ni Close ni delete ne sont ncessaire avant ou aprs
    // l'utilisation de Kill).
    // L'interet de la fonction est qu'elle s'assure que les oprations du socket sont
    // termines et s'assure que les fonctions de rappelles sont termines avant de dtruire
    // le socket. Cela permet d'appeler cette fonction au sein mme d'une fonction de rappel
    // en sachant que le traitement pourra se terminer correctement. Cette fonctionnalit est
    // trs utile pour les serveurs.
    // Nanmoins, vous devez quitter toutes les fonctions de rappels aprs l'appel  Kill,
    // particulirement une fonction grant l'vnement OnConnect (typiquement vous avez 20
    // secondes pour tout fermer).


    ////   FONCTIONS DE RAPPEL   ////
    // Les 4 fonctions qui suivent servent  dfinir ou redfinir les fonctions qui sont
    // appeles lors de certains vnements de l'objet mk_socket.
    // Elle prenent toutes en paramtres un pointeur vers la fonction de rappel et un
    // paramtre qui peut tre ce que vous voulez qui sera pass  la fonction. Cela
    // permet d'utiliser la mme fonction de rappel pour plusieurs mk_socket diffrents.

    // Toutes les fonctions de rappels recoivent en paramtres l'objet mk_socket qui a
    // dclench l'vnement ainsi que le paramtre de type (void*) qui vous avez dfini
    // lors de l'appel  l'une des 4 fonctions qui suivent.

    // Pour annuler la dfinition d'une fonction de rappel, appeler la fonction qui sers
    //  la dfinir avec des parenthse vides.

    void SetOnConnectCallBack(void (*onconnect)(mk_socket&,void*)=NULL,void* data=NULL);
    // L'vnement OnConnect se dclanche lorsque que le socket se connecte  un autre
    // socket, que ce soit aprs un appel  Connect, ou  Accept.

    void SetOnCloseCallBack(void (*onclose)(mk_socket&,void*)=NULL,void* data=NULL);
    // L'vnement OnClose se produit lorsque la connexion se ferme. Que ce soit parceque
    // le socket distant a ferm la connexions, ou que suite  un appel  Close.

    void SetConnectionRequestCallBack(void (*onrequest)(mk_socket&,void*)=NULL,void* data=NULL);
    // L'vnement ConnectionRequest se produit lorsqu'un socket en mode LISTEN recoit une
    // demande de connexions. C'est au cours de cet vnement, et l seulement, que vous
    // pouvez appeler Accept. Si vous ne le faites pas, la connexions est refus au socket
    // qui a tent de se connecter.
    // Il faut noter que si vous avez une socket en mode LISTEN, vous devez obligatoirement,
    // dfinir la fonction de rappel pour cet vnement. Et c'est la seule : dans tout les
    // cas, pour les autres vnements, la fonction de rappel est facultative.

    void SetDataArrivalCallBack(void (*dataarrival)(mk_socket&,char*,int,void*)=NULL,void* data=NULL);
    // L'vnement DataArrival se produit lorsque des donnes sont reus pas le socket.
    // La fonction de rappel recoit, en plus des paramtres habituels, un pointeurs vers
    // un tableau de char qui contient les donnes recu et en entier qui spcifie la taille
    // de ces donnes. Le tableau de caractres est allou statiquement pour chaque instance
    // de la classe mk_socket. Vous devez donc traiter ou recopier les donnes avant la fin
    // de la fonction de rappel.
    // De plus, les donnes lues n'excderont jamais BUFFER_SIZE octets d'un coup.

    void SetOnErrorCallBack(void (*onerror)(mk_socket&,int,void*)=NULL,void* data=NULL);
    // L'vnement OnError se produit lorsqu'une erreur apparait dans le traitement d'une
    // fonction. Deux cas sont possibles : soit l'erreur apparait dans le traitement d'une
    // fonction membre de la classe que vous avez appele. Dans ce cas, la fonction renvoie
    // en question renvoie false. L'vnement OnError est alors dclench dans le mme
    // thread que celui de la fonction fautive AVANT que cette fonction ne rende la main.
    // Ceci vous permet par exemple d'enregistrer la valeur de l'erreur passe  la fonction
    // de rappel dans une variable globale sur le mme modle que la variable errno, et que
    // vous pourrez donc interroger ultrieurement.
 
// Parmis les fonctions de rappel, seule celle ragissant  l'vnement OnConnect n'est pas
// bloquante. C'est--dire que lorsque la fonction enregistr pour l'vnement OnConnect est
// appel par la bibliothque, elle est appele dans le contexte d'un nouveau thread, ce qui
// vous permet de faire durer le traitement de cette fonction aussi longtemps que vous le
// souhaitez. Par contre, les autres fonctions sont appeles dans le contexte du thread en
// cours (qui dpend de la fonction en question) et doivent donc rendre la main "rapidement".

  private:
    SOCKET sock,new_sock;
    void thread_proc();
    void (*DataArrival)(mk_socket &sock,char* str,int len,void* data);
    void (*OnConnect)(mk_socket&,void*);     //Cette fonction est appell aprs l'tablissement de la connexion
    void (*OnConnectionRequest)(mk_socket&,void*);     //Cette fonction est appell aprs l'tablissement de la connexion
    void (*OnClose)(mk_socket&,void*);   //Cette fonction est appell
    void (*OnError)(mk_socket&,int,void*);
    void* DataArrival_Data;
    void* Connect_Data;
    void* ConnectionRequest_Data;
    void* Close_Data;
    void* Error_Data;
    int proc_count;
    ETAT etat;
#ifdef WIN32
    WSADATA *Sock_Data; 
#endif
    friend CALLBACK_PROC mk_SckProc(void* lpParameter);
    friend CALLBACK_PROC mk_ConnectProc(void* lpParameter);
    friend CALLBACK_PROC mk_DieProc(void* lpParameter);

};

// Ce qui suis est la liste des erreurs qui peuvent tre passes en argument  la fonction
// grant l'vnement OnError. Come vous le remarquerez, cette liste est courte car la gestion
// d'erreur selon cette mthode est encore inachev.
#define SUCCESS                   0   /* Il n'y a pas d'erreur. */
#define STATE_IS_NOT_IDLE         1   /* L'objet doit tre dans l'tat IDLE avant que vous appeliez cette fonction. */
#define BAD_HOSTNAME              2   /* Le nom de domaine demandez n'a pas pu tre rsolu. Il est soit invalide, soit le serveur DNS n'a pas pu tre contact. */

#endif

/*
P.S. Je tiens  remercier Brian Hall l'auteur d'un trs bon tutorial sur l'utilisation des
sockets. On pourra trouver ce tutorial l : http://beej.us/guide/bgnet/
*/

